#!/usr/bin/env python
# -*- coding: utf-8 -*-
# File  : main_survival.py
# Author: My Duan
# Date  : 2022-09-23

from DQSurv import *
import os


def main():

	data = pd.read_csv(data_file, index_col=0)
	survival = pd.read_csv(survival_file, index_col=0)
	driver = list(pd.read_csv(driver_file, header=None).iloc[:, 0].values)
	target = list(pd.read_csv(target_file, header=None).iloc[:, 0].values)
	adj = pd.read_csv(adj_matrix).values
	edge_index = get_adjency(adj)

	# times = 10

	obj_data, survival_label = get_data(data, survival, driver, target,
										missing_value='-9.9658', log_transform=False)

	if pretrained == False:
		DQSurv(obj_data, survival_label, driver, target, edge_index,
	   pretrained_model_path = HealthModel_path, model_path = myFolderO, pretrained=pretrained, saved_flag=True)

	elif pretrained == True:
		DQSurv(obj_data, survival_label, driver, target, edge_index,
	   pretrained_model_path = HealthModel_path, model_path = myFolderO, pretrained=pretrained, saved_flag=True)

	else:
		print('Please input True/False !')

if __name__ == '__main__':

	opt = parse_args()

	# data [samples, genes->EGSG omiv the version]
	# survival [samples, survival-> OS, OS.time]

	# myFolderD = './HealthModel-v8/data'
	# myFolderM = './HealthModel-v8//model'


	if len(sys.argv) != 5:
		print("-Error in syntax!")
		print(
			"python main.py <data folder> <model folder> <output folder> <pretrained>")
		exit(-1)
	else:
		myFolderD = sys.argv[1]  # data foder myFolderD = '../data'
		myFolderM = sys.argv[2]  # model folder myFolderM = '../model'
		myFolderO = sys.argv[3]  # output folder
		pretrained = sys.argv[4]# True or Flase

		if pretrained == 'True':
			pretrained = True
		elif pretrained == 'False':
			pretrained = False
		else:
			print('Please input True/False !')


		if not os.path.exists(myFolderD) or not os.path.exists(myFolderM):
			print('Input File Error !')
			exit()
		if not os.path.exists(myFolderO):
			os.makedirs(myFolderO)
		else:
			pass

		data_file = myFolderD + '/' + 'data.csv'
		survival_file = myFolderD + '/' + 'label.csv'

		driver_file = myFolderM + '/' + 'regulatory_geneIDs.csv'
		target_file = myFolderM + '/' + 'target_geneIDs.csv'
		adj_matrix = myFolderM+ '/' + 'adjacent_matrix.csv'
		HealthModel_path = myFolderM + '/' + 'HealthModel.pth'

		main()





